> For the complete documentation index, see [llms.txt](https://docs.digitalsamba.com/reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.digitalsamba.com/reference/rest-api/polls/create.md).

# Create

To create a predefined poll you need to execute a **POST** request against the **/rooms/:id/polls** endpoint.

Predefined polls are loaded on session start.

You need to specify the poll question and also an array of the poll options. With the **multiple** param you can control if is a multiple choice question or not.

{% hint style="info" %}
A poll can be configured to be **anonymous** - that means nobody in the room will be able to see who voted for what exact option. Only the total amount of votes will be seen, but not the concrete users.
{% endhint %}

#### Request

{% tabs %}
{% tab title="cURL" %}
{% code overflow="wrap" %}

```bash
curl --request POST \
  --header "Content-Type: application/json" \
  --url https://api.digitalsamba.com/api/v1/rooms/c39d7c40-7ff7-4faa-b06f-698a639a9523/polls \
  --user YOUR_TEAM_ID:YOUR_DEVELOPER_KEY \
  --data '{"question": "How many languages do you speak?", "multiple": false, "anonymous": false, "options": [{"text": "One"}, {"text": "Two"},{"text": "Three"}, {"text": "More than three"}]}'
```

{% endcode %}
{% endtab %}

{% tab title="Java" %}

```java
import com.fasterxml.jackson.databind.ObjectMapper;

import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.net.http.HttpResponse.BodyHandlers;
import java.util.Base64;
import java.util.Map;

String TEAM_ID = "YOUR_TEAM_ID";
String DEVELOPER_KEY = "YOUR_DEVELOPER_KEY";
String authorizationHeader = "Bearer " + Base64.getEncoder().encodeToString((TEAM_ID + ":" + DEVELOPER_KEY).getBytes());

//Put your room id or friendly_url (name) here - this value is just an example
String roomId = "c39d7c40-7ff7-4faa-b06f-698a639a9523";

Map<String, Object> data = Map.of(
    "question", "How many languages do you speak?",
    "multiple", false,
    "anonymous", false,
    "options", new Object[] { 
        Map.of("text", "One"),
	      Map.of("text", "Two"),
	      Map.of("text", "Three"),
	      Map.of("text", "More than three")
    }			
);
String jsonData = new ObjectMapper().writeValueAsString(data);

HttpRequest request = HttpRequest.newBuilder()
  .POST(HttpRequest.BodyPublishers.ofString(jsonData))
  .uri(new URI("https://api.digitalsamba.com/api/v1/rooms/" + roomId + "/polls"))
  .header("Authorization", authorizationHeader)
  .header("Content-Type", "application/json")
  .build();

HttpClient client = HttpClient.newHttpClient();
HttpResponse<String> response = client.send(request, BodyHandlers.ofString());

System.out.println("Status code: " + response.statusCode());
System.out.println("Body: " + response.body());
```

{% endtab %}
{% endtabs %}

#### Response (200 OK)

```json
{
    "id": "c15102d9-ed47-468c-8e5a-86be0c97c296",
    "question": "How many languages do you speak?",
    "anonymous": false,
    "multiple": false,
    "status": "created",
    "options": [
        {"id":"f7524f3d-41f9-46bc-9dbf-918d5fd39618", "text":"One"},
        {"id":"1a4879dc-3a93-4e3d-8cae-5e1e6ed878f9", "text":"Two"},
        {"id":"f8877655-4470-4b26-9834-cd5016da79c3", "text":"Three"},
        {"id":"9b7c51c8-bc62-46db-8b7e-e28ed5d4d336", "text":"More than three"}
    ],
    "created_at":"2024-06-27T06:49:45Z"
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.digitalsamba.com/reference/rest-api/polls/create.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
